﻿Imports System.Data.SqlClient

Public Class frmConsultas




    Dim ds As New DataSet
    Dim TablaHojasConsulta As New DataTable
    Dim cbbEmpleado As New ComboBox

    'Creamos el objeto proxy
    Dim obj As New ServiceReference1.Service1Client()

    Private Sub btnAtras_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAtras.Click
        Me.Close()
    End Sub


    Private Sub frmConsultas_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Try

            'El servicio nos devuelve un dataset. Como solo nos interesa la tabla hojas
            'la guardamos en nuestra tabla
            Dim datasetalt As New DataSet
            Dim TablaHojasUtil As New DataTable("Hoja")


            Try
                If consulta = "Normal" Then
                    datasetalt = obj.HojasEmpleado(cod_emp)
                    ConsultaNormal()
                Else
                    If consulta = "Departamento" Then
                        datasetalt = obj.HojasDepartamento(dept_emp)
                        ConsultaJefeDepartamento()
                    Else
                        If consulta = "Proyecto" Then
                            datasetalt = obj.HojasProyecto(ProyectoResponsable)
                            ConsultaJefeProyecto()
                        End If
                    End If
                End If

            Catch ex As Exception
                MessageBox.Show(ex.Message + "El servicio está caido")
                End
            End Try

            TablaHojasUtil = datasetalt.Tables(0)
            TablaHojasConsulta = TablaHojasUtil.Copy

            'Liberamos memoria
            datasetalt.Dispose()
            TablaHojasUtil.Dispose()

            CargarHojas()

        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub CargarHojas()

        Try
            cbbIDhoja.DataSource = TablaHojasConsulta
            cbbIDhoja.DisplayMember = "id_hoja"
            cbbIDhoja.ValueMember = "id_hoja"
            cbbIDhoja.DropDownStyle = ComboBoxStyle.DropDownList
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub ConsultaNormal()
        Try
            panelCriterios.Controls.Clear()
            panelCriterios.Location = New Size(22, 118)
            panelCriterios.Size = New Size(652, 177)

            panelEstado.Location = New Size(28, 317)
           

            panelCriterios.Controls.Add(rbIdhoja)
            panelCriterios.Controls.Add(lblidhoja)
            panelCriterios.Controls.Add(rbCampos)
            panelCriterios.Controls.Add(cbbIDhoja)
            panelCriterios.Controls.Add(lblReferencia)
            panelCriterios.Controls.Add(panelReferencia)
            panelCriterios.Controls.Add(txtProyectos)
            panelCriterios.Controls.Add(btnProyectos)
            panelCriterios.Controls.Add(lblLocalidad)
            panelCriterios.Controls.Add(txtLocalidad)
            panelCriterios.Controls.Add(lblMotivo)
            panelCriterios.Controls.Add(txtMotivo)
            panelCriterios.Controls.Add(lblFechas)
            panelCriterios.Controls.Add(dtpFecha1)
            panelCriterios.Controls.Add(dtpFecha2)
            panelCriterios.Controls.Add(lblletra)


            panelReferencia.Controls.Add(rbDepartamento)
            panelReferencia.Controls.Add(rbProyecto)
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub


    Private Sub ConsultaJefeDepartamento()
        Try

            'Cargo los empleados del departamento
            Dim TablaEmpleados As New DataTable


            Dim filas() As DataRow = dataset.Tables("Empleado").Select("Cod_dept = " + dept_emp.ToString)
            TablaEmpleados = dataset.Tables("Empleado").Clone

            'TablaEmpleados.Select("Cod_dept = " + dept_emp.ToString)
            Dim y As Integer = 0

            'For y = 0 To filas.Length - 1
            For Each row As DataRow In filas
                TablaEmpleados.ImportRow(row)
            Next

            TablaEmpleados.Columns.RemoveAt(5)
            TablaEmpleados.Columns.RemoveAt(4)
            TablaEmpleados.Columns.RemoveAt(3)
            TablaEmpleados.Columns.RemoveAt(2)

            'Insertamos una columna, la primera, que tendrá el valor de Todos.
            Dim filanull As DataRow = TablaEmpleados.NewRow

            filanull(1) = " - Todos - "
            filanull(0) = "0"
            TablaEmpleados.Rows.Add(filanull)

            'La etiqueta y combobox para buscar por empleado
            Dim lblEmpleado As New Label
            lblEmpleado.Visible = True
            lblEmpleado.Text = "Empleado:"
            lblEmpleado.Size = New Size(60, 13)
            lblEmpleado.Location = New Size(24, 84)

            Dim VistaOrdenarEmpleados As New DataView(TablaEmpleados)

            cbbEmpleado.Visible = True
            cbbEmpleado.Size = New Size(230, 13)
            cbbEmpleado.Location = New Size(122, 83)
            VistaOrdenarEmpleados.Sort = ("Nombre, Cod_emp")


            cbbEmpleado.DataSource = VistaOrdenarEmpleados
            cbbEmpleado.DisplayMember = "Nombre"
            cbbEmpleado.ValueMember = "Cod_emp"
            cbbEmpleado.DropDownStyle = ComboBoxStyle.DropDownList


            ' Recolocamos todos los objetos
            Dim i As Integer = 34
            panelCriterios.Controls.Clear()
            panelCriterios.Location = New Size(22, 118)
            panelCriterios.Size = New Size(652, 177 + i)

            panelEstado.Location = New Size(28, 317 + i)
            LineShape2.Y1 = 304 + i
            LineShape2.Y2 = 304 + i
            LineShape3.Y1 = 428 + i
            LineShape3.Y2 = 428 + i
            btnAtras.Location = New Size(49, 445 + i)
            btnBuscar.Location = New Size(569, 445 + i)
            Me.Size = New Size(731, 522 + i)

            rbIdhoja.Location = New Size(5, 12)
            lblidhoja.Location = New Size(143, 14)
            cbbIDhoja.Location = New Size(256, 12)
            rbCampos.Location = New Size(5, 51)
            lblReferencia.Location = New Size(24, 84 + i)
            panelReferencia.Location = New Size(122, 76 + i)
            txtProyectos.Location = New Size(367, 82 + i)
            btnProyectos.Location = New Size(473, 80 + i)
            lblLocalidad.Location = New Size(24, 115 + i)
            txtLocalidad.Location = New Size(106, 112 + i)
            lblMotivo.Location = New Size(266, 115 + i)
            txtMotivo.Location = New Size(335, 112 + i)
            lblFechas.Location = New Size(24, 149 + i)
            dtpFecha1.Location = New Size(147, 144 + i)
            dtpFecha2.Location = New Size(335, 144 + i)
            lblletra.Location = New Size(295, 149 + i)


            rbDepartamento.Location = New Size(14, 6)
            rbProyecto.Location = New Size(119, 6)

            panelCriterios.Controls.Add(rbIdhoja)
            panelCriterios.Controls.Add(lblidhoja)
            panelCriterios.Controls.Add(rbCampos)
            panelCriterios.Controls.Add(cbbIDhoja)
            panelCriterios.Controls.Add(lblReferencia)
            panelCriterios.Controls.Add(panelReferencia)
            panelCriterios.Controls.Add(txtProyectos)
            panelCriterios.Controls.Add(btnProyectos)
            panelCriterios.Controls.Add(lblLocalidad)
            panelCriterios.Controls.Add(txtLocalidad)
            panelCriterios.Controls.Add(lblMotivo)
            panelCriterios.Controls.Add(txtMotivo)
            panelCriterios.Controls.Add(lblFechas)
            panelCriterios.Controls.Add(dtpFecha1)
            panelCriterios.Controls.Add(dtpFecha2)
            panelCriterios.Controls.Add(lblletra)
            panelCriterios.Controls.Add(lblEmpleado)
            panelCriterios.Controls.Add(cbbEmpleado)

            panelReferencia.Controls.Add(rbDepartamento)
            panelReferencia.Controls.Add(rbProyecto)


        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub ConsultaJefeProyecto()
        Try

            ' Cargo los empleados del departamento
            Dim TablaEmpleados As New DataTable

            'El servicio nos devuelve un dataset. No debe machacar nuestro dataset
            'Asique lo sacamos a tabla, lo copiamos a una nueva,  y esta tabla la añadimos
            'a nuestro dataset
            Dim datasetalt As New DataSet
            Dim TablaAlternativa As New DataTable("Empleado")

            Try
                datasetalt = obj.EmpleadosdeProyecto(ProyectoResponsable)
            Catch ex As Exception
                MessageBox.Show("El servicio está caido")
                'Return
                End
            End Try

            TablaAlternativa = datasetalt.Tables(0)
            TablaEmpleados = TablaAlternativa.Copy


            obj.Close()
            datasetalt.Dispose()

            
            'Insertamos una fila que mostrara todos.
            Dim filanull As DataRow = TablaEmpleados.NewRow

            filanull(1) = " - Todos - "
            filanull(0) = "0"
            TablaEmpleados.Rows.Add(filanull)

            'La etiqueta y combobox para buscar por empleado
            Dim lblEmpleado As New Label
            lblEmpleado.Visible = True
            lblEmpleado.Text = "Empleado:"
            lblEmpleado.Size = New Size(60, 13)
            lblEmpleado.Location = New Size(24, 84)

            Dim VistaOrdenarEmpleados As New DataView(TablaEmpleados)

            cbbEmpleado.Visible = True
            cbbEmpleado.Size = New Size(230, 13)
            cbbEmpleado.Location = New Size(106, 83)
            VistaOrdenarEmpleados.Sort = ("Nombre, Cod_emp")


            cbbEmpleado.DataSource = VistaOrdenarEmpleados
            cbbEmpleado.DisplayMember = "Nombre"
            cbbEmpleado.ValueMember = "Cod_emp"
            cbbEmpleado.DropDownStyle = ComboBoxStyle.DropDownList
            panelCriterios.Controls.Add(lblEmpleado)
            panelCriterios.Controls.Add(cbbEmpleado)

            lblReferencia.Visible = False
            panelReferencia.Visible = False
            txtProyectos.Visible = False
            btnProyectos.Visible = False
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
    Private Sub rbIdhoja_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbIdhoja.CheckedChanged
        Try

            'Si busca por id de hoja, deshabilitamos todo lo demas. Sino, al reves
            If (rbIdhoja.Checked = True) Then
                cbbIDhoja.Enabled = True

                txtLocalidad.Enabled = False
                txtMotivo.Enabled = False
                txtProyectos.Enabled = False
                dtpFecha1.Enabled = False
                dtpFecha2.Enabled = False
                rbDepartamento.Enabled = False
                rbProyecto.Enabled = False

                cboxActiva.Enabled = False
                cboxCancelada.Enabled = False
                cboxCerrada.Enabled = False

                cbbEmpleado.Enabled = False

            Else
                cbbIDhoja.Enabled = False

                txtLocalidad.Enabled = True
                txtMotivo.Enabled = True
                txtProyectos.Enabled = True
                dtpFecha1.Enabled = True
                dtpFecha2.Enabled = True
                rbDepartamento.Enabled = True
                rbProyecto.Enabled = True

                cboxActiva.Enabled = True
                cboxCancelada.Enabled = True
                cboxCerrada.Enabled = True
                cbbEmpleado.Enabled = True


                If rbProyecto.Checked = True Then
                    txtProyectos.Enabled = True
                    btnProyectos.Enabled = True

                Else
                    txtProyectos.Enabled = False
                    btnProyectos.Enabled = False
                End If
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub
    Private Sub btnBuscar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBuscar.Click
        Try

            Dim dvHojasUserConsultadas As DataView
            'Creamos un string expresion para hacer el filtro a la vista. 
            'Esta variable la vamos modificando segun los criterios que haya introducido
            Dim expresion As String = ""

            If (rbIdhoja.Checked = True) Then

                'Abrimos de forma modal
                Using frm As New frmDetallesHoja(cbbIDhoja.SelectedValue.ToString)
                    frm.ShowDialog(Me)
                End Using
            Else
                dvHojasUserConsultadas = New DataView(TablaHojasConsulta)

                expresion = "Fecha_creada >='" + dtpFecha1.Value.Date + "' AND Fecha_creada <='" + dtpFecha2.Value.Date + "'"


                If (consulta = "Normal" Or consulta = "Departamento") Then
                    If (rbDepartamento.Checked = True) Then
                        expresion = expresion + " AND Referencia = " + dept_emp.ToString
                    Else
                        If Not String.IsNullOrEmpty(txtProyectos.Text) Then
                            expresion = expresion + " AND Referencia = " + txtProyectos.Text
                        Else
                            expresion = expresion + " AND Referencia <> " + dept_emp.ToString
                        End If
                    End If
                End If


                If Not String.IsNullOrEmpty(txtLocalidad.Text) Then
                    expresion = expresion + " AND Localidad='" + txtLocalidad.Text.ToString + "'"
                End If

                If Not String.IsNullOrEmpty(txtMotivo.Text) Then
                    expresion = expresion + " AND Motivo ='" + txtMotivo.Text + "'"
                End If


                'MessageBox.Show(dtpFecha1.Value.Date)

                If cboxActiva.Checked = True Then
                    If cboxCerrada.Checked = True Then
                        If cboxCancelada.Checked = False Then
                            expresion = expresion + " AND (Estado = 'Abierta' OR Estado = 'Aprobada' OR Estado = 'Cerrada')"
                        End If
                    Else
                        If cboxCancelada.Checked = True Then
                            expresion = expresion + " AND (Estado = 'Abierta' OR Estado = 'Aprobada' OR Estado = 'Cancelada')"
                        Else
                            expresion = expresion + " AND (Estado = 'Abierta' OR Estado = 'Aprobada')"
                        End If
                    End If

                Else
                    If cboxCerrada.Checked = True Then
                        'dvHojasUserConsultadas.RowFilter = "Estado = Cerrada"

                        If (cboxCancelada.Checked = True) Then
                            expresion = expresion + " AND Estado = 'Cerrada'"
                        Else
                            expresion = expresion + " AND (Estado = 'Cerrada' OR Estado = 'Cancelada')"
                        End If
                    Else
                        If cboxCancelada.Checked = True Then
                            expresion = expresion + " AND Estado = 'Cancelada'"
                        End If
                    End If
                End If


                If consulta = "Departamento" Or consulta = "Proyecto" Then
                    If (cbbEmpleado.SelectedValue.ToString <> "0") Then
                        expresion = expresion + " AND  Cod_emp=" + cbbEmpleado.SelectedValue.ToString
                        ' MessageBox.Show(cbbEmpleado.SelectedValue.ToString)

                        dvHojasUserConsultadas.RowFilter = expresion
                        Using frm As New frmResultado(dvHojasUserConsultadas)
                            frm.ShowDialog(Me)
                        End Using
                    Else
                        dvHojasUserConsultadas.RowFilter = expresion
                        Using frm As New frmResultado(dvHojasUserConsultadas, True)
                            frm.ShowDialog(Me)
                        End Using
                    End If
                Else
                    dvHojasUserConsultadas.RowFilter = expresion
                    Using frm As New frmResultado(dvHojasUserConsultadas)
                        frm.ShowDialog(Me)
                    End Using
                End If
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    Private Sub rbProyecto_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbProyecto.CheckedChanged
        Try
            If rbProyecto.Checked = True Then
                txtProyectos.Enabled = True
                btnProyectos.Enabled = True
                txtProyectos.Text = ""
            Else
                txtProyectos.Enabled = False
                btnProyectos.Enabled = False
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try
    End Sub

    Private Sub btnProyectos_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProyectos.Click

        'Abrimos de forma modal el formulario util, que tendrá los proyectos en los que trabaja
        'el empleado
        'En caso de venir la consulta de departamneto, mostramos los proyectos del departamento
        Using frm As New frmUtil()
            If consulta = "Normal" Then
                frm.ProyectosTrabajaEmpleado()
            Else
                If consulta = "Departamento" Then
                    frm.ProyectosDepartamento()
                End If
            End If

            Dim dr As DialogResult = frm.ShowDialog(Me)

            If (dr = Windows.Forms.DialogResult.OK) Then
                txtProyectos.Text = CStr(frm.Proyecto_elegido)
            Else
                If dr = Windows.Forms.DialogResult.Ignore Then
                    rbDepartamento.Checked = True
                Else
                    MessageBox.Show("No ha seleccionado ningún proyecto", "Proyecto no seleccionado", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    txtProyectos.Text = ""
                End If
            End If
        End Using
    End Sub


End Class