﻿Public Class frmResultado

    Dim dvHojasUser As DataView
    Dim id_hoja As Integer
    'Variable que controlamos para mostrar tambien la columna empleado
    Dim MostrarEmpleado As Boolean = False

    Private Sub frmResultado_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        dgvResultado.DataSource = dvHojasUser

        If (dvHojasUser.Count = 0) Then
            dgvResultado.Visible = False
            lblNoResul.Location = New Size(248, 239)
            lblNoResul.Visible = True
        Else
            lblNoResul.Visible = False
            dgvResultado.ReadOnly = True
            dgvResultado.AllowUserToAddRows = False
            dgvResultado.Columns("Cod_emp").Visible = False
            dgvResultado.Columns("Fecha_aprobacion").Visible = False
            dgvResultado.Columns("Fecha_autorizada").Visible = False
            dgvResultado.Columns("Cod_aprobada").Visible = False
            dgvResultado.Columns("Cod_autorizada").Visible = False
            dgvResultado.Columns("Fecha_origen").Visible = False
            dgvResultado.Columns("Fecha_destino").Visible = False
            dgvResultado.Columns("Motivo_rechazo").Visible = False
            dgvResultado.AutoSizeColumnsMode = DataGridViewAutoSizeColumnsMode.Fill

            If MostrarEmpleado Then
                dgvResultado.Columns("Cod_emp").Visible = True
            End If
        End If


    End Sub

    Public Sub New(ByVal dv As DataView)

        ' Llamada necesaria para el diseñador.
        InitializeComponent()

        ' Agregue cualquier inicialización después de la llamada a InitializeComponent().
        dvHojasUser = dv
        MostrarEmpleado = False
    End Sub

    Public Sub New(ByVal dv As DataView, ByVal gb As Boolean)

        ' Llamada necesaria para el diseñador.
        InitializeComponent()

        ' Agregue cualquier inicialización después de la llamada a InitializeComponent().
        dvHojasUser = dv
        MostrarEmpleado = True
    End Sub

    Private Sub dgvResultado_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles dgvResultado.DoubleClick
        Dim indice As Integer

        indice = Me.dgvResultado.CurrentCell.RowIndex
        id_hoja = Me.dgvResultado.Item(0, indice).Value

        'Abrimos los detalles de una hoja de forma modal
        Using frm As New frmDetallesHoja(id_hoja)
            Me.Hide()
            frm.ShowDialog(Me)
            Me.Close()
        End Using

    End Sub
End Class